/* $Id: rpmpldi.c,v 1.9 2001/10/14 08:42:31 pawelk Exp $ */
#include "rpmpldi.h"

static int Close=0;

#define dbStart if(!rpmmen_pkgs.db){ \
			Close=1; \
			rpmpkgs_opendb(&rpmmen_pkgs); \
		}else {Close=0 ; }

#define dbStop if(Close) rpmpkgs_close(&rpmmen_pkgs);
		
static TPkgSet rpmmen_pkgs;

TPkgSet *rpmpldi_getPkgsSet()
{
	return &rpmmen_pkgs;
}

void rpmpldi_select_from_file(char *name)
{
	rpmpkgs_select_from_file(&rpmmen_pkgs, name);
}

int rpmpldi_install(int flags	/*, rpmNotifyFunction notify, TStartPackage
				   startUI */ )
{
	return rpmpkgs_install(&rpmmen_pkgs, flags /*, notify, startUI */ );
}

int rpmpldi_init(char *src, char *dest, struct rpmmen_cb *cb)
{
	rpmpkgs_init(&rpmmen_pkgs, src, dest, cb);
	return (rpmpkgs_opendb(&rpmmen_pkgs));
}

/* same as rpmpldi_init but open base in readonly mode */
int rpmpldi_init_ro(char *src, char *dest, struct rpmmen_cb *cb)
{
	rpmpkgs_init(&rpmmen_pkgs, src, dest, cb);
	return (rpmpkgs_opendb_ro(&rpmmen_pkgs));
}

int rpmpldi_scandir()
{
	return rpmpkgs_scandir(&rpmmen_pkgs);
}

void rpmpldi_finish()
{
	rpmpkgs_close(&rpmmen_pkgs);
	rpmpkgs_free(&rpmmen_pkgs);
}

void *rpmpldi_header_entry_get(int num, int tag)
{
	return rpmpkg_header_entry_get(&rpmmen_pkgs, num, tag);
}

void rpmpldi_header_entry_free(void *ptr)
{
	rpmpkgs_header_entry_free(ptr);
}
/*RET: number of conflicts */
int rpmpldi_add_deps()
{
	int ret;
	dbStart;
	log_debug_message(_("It's time for dependencies"));
	ret= rpmpkgs_addPkgsDep(&rpmmen_pkgs);
	dbStop;
	return(ret);
}

void rpmpldi_remove_deps()
{
	rpmpkgs_removePkgsDep(&rpmmen_pkgs);
}

unsigned long rpmpldi_selected_size(int *n)
{
    return rpmpkgs_selected_size(&rpmmen_pkgs, n);
}

void rpmpldi_selectpackages(char **names,int count)
{
	rpmpkgs_selectpackages(&rpmmen_pkgs,names,count);
}

void rpmpldi_closedb()
{
	rpmpkgs_close(&rpmmen_pkgs);
}

void rpmpldi_opendb()
{
	rpmpkgs_opendb(&rpmmen_pkgs);
}

void rpmpldi_update_installed_info()
{
	rpmpkgs_update_info(&rpmmen_pkgs);
}

tn_list * rpmpldi_allRequired(char *name,TpkgDescribe *pk)
{
	return (allRequired(&rpmmen_pkgs,name,pk));
}

TpkgDescribe rpmpldi_getPkgDesc(char *name)
{
	return rpmpkgs_getPkgDesc(&rpmmen_pkgs,name);
}

tn_list * rpmpldi_check_black()
{
	return rpmpkgs_checkBlack(&rpmmen_pkgs);
}
void rpmpldi_freeBlack(tn_list *list)
{
	rpmmen_freeBlack(list);
}

int rpmpldi_is_installed(char *name, char *evr)
{
	return rpmpkgs_isInstalled(&rpmmen_pkgs,name, evr);
}
